
import pygame
import pygame.gfxdraw
from pygame.locals import *
import random
import zipfile
import os


presentation=[("LliureX Dev Team",None),("Is proud to announce",None),("LliureX 10.09 (Leia)",None),("Commanded by:",None),("Luis G.G. (oneliner)","2"),("Coded by:",None),("Enrique M.G. (Lt_Henry)","3"),("Hector G.H. (Cless)","4"),("Raul R.S. (Kbut)","6"),("Angel B.V. (x4ng3l)","1"),("Alfons L.S. (turix)","7"),("David M.F. (volat)","12"),("Nacho Vidal!!","10"),("Jose A. (El de la comarca) ","13"),("translated by:",None),("Pilar E.G. (pilarize)","5"),("Javi G. (Indurain)","8"),("Hardware support:",None),("Javi E. (Lord Wolf)","9"),("Documented by:",None),("Soledad (Hello kitty)","14"),("David P. (El bibliotecas)","16"),("Jose C. (wikicarlos)","15"),("and remember...",None),("All your lliurex are belong to us","11")]

images_to_load=["1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16"]

images={}

base_path="/tmp/.lliurex-credits/"
zip_path=base_path + "lliurex-credits.zip"

def main():
	os.system("rm -rf " + base_path)
	os.mkdir(base_path)
	os.system("cat /usr/share/zero-center/lliurex-credits/data.bin | uudecode -o " + zip_path)
	#os.system("cat data.bin | uudecode -o " + zip_path)
	zip=zipfile.ZipFile(zip_path)
	zip.extractall(base_path)
	exit_request=False
	slide=0
	mode=0
	tx=0
	vx=0.0
	wait_time=0
	tmpsrf=None
	facesrf=None
	timer = pygame.time.Clock()
	
	#creating stars
	stars=[]
	for s in range(1,80):
		x=random.randint(0,600)-300
		y=random.randint(0,600)-300
		z=random.randint(1,80)
		
		stars.append( (x,y,z) )
	
	
	
	pygame.init()
	screen=pygame.display.set_mode((400,400),pygame.DOUBLEBUF)
	pygame.display.set_caption("LliureX Team")

	for im in images_to_load:
		print("Loading "+im)
		tmp=pygame.image.load(base_path+im)
		images[im]=tmp

	lliurex_logo=pygame.image.load(base_path + "main")
	lcd_font=pygame.font.Font(base_path + "dotmatrix.ttf",16)
	
	pygame.mixer.music.load(base_path + "origen")
	pygame.mixer.music.play()

	while not exit_request:
		key_pressed = pygame.key.get_pressed()
		if key_pressed[K_ESCAPE]:
			exit_request=True
			
		for event in pygame.event.get():
			if event.type==QUIT:
				exit_request=True
				
		screen.fill((0,0,0))
		screen.blit(lliurex_logo,(0,0))
		
		if mode==3:
			vx=vx+0.2
			tx=tx+vx
			screen.blit(tmpsrf,(tx,200))
			
			alpha=tx*255/400
			if not facesrf==None:
				facesrf.set_alpha(255-alpha)
				screen.blit(facesrf,(200-facesrf.get_width()/2,240))
			
			if tx>400:
				mode=0
		
		
		if mode==2:
			screen.blit(tmpsrf,(200-tmpsrf.get_width()/2,200))
			if not facesrf==None:
				screen.blit(facesrf,(200-facesrf.get_width()/2,240))
				
			wait_time=wait_time+timer.get_time()
			if wait_time>2600:
				mode=mode+1
				vx=0.0
				
		
		if mode==1:
			vx=vx+0.2
			tx=tx+vx
			if vx>5.0:
				vx=5.0
				
			screen.blit(tmpsrf,(tx,200))
			dest_tx=200-tmpsrf.get_width()/2
			
			alpha=tx*255/dest_tx
			if not facesrf==None:
				facesrf.set_alpha(alpha)
				screen.blit(facesrf,(200-facesrf.get_width()/2,240))
			
			if tx>=dest_tx:
				mode=mode+1
				wait_time=0
		
		if mode==0:
			text,face=presentation[slide]
			if not face==None:
				facesrf=images[face]
			else:
				facesrf=None
				
			slide=slide+1
			if slide==len(presentation):
				slide=0
				
			tmpsrf=lcd_font.render(text,True,(63,213,63))	
			mode=mode+1
			tx=-tmpsrf.get_width()
			vx=0.1
			
			
		for n in range(0,len(stars)):
			x,y,z=stars[n]
			z=z-1
			if z<1:
				z=80
			px=x/z
			py=y/z
			stars[n]=(x,y,z)
			pygame.gfxdraw.box(screen,(200+px,150+py,2,2),(255,255,255))
			
		
		timer.tick(60)
		pygame.display.flip()

	#closing area
	


if __name__ == '__main__': main()
